REM *********************************************************************
REM *********************************************************************
REM *****                                                            ****
REM *****         MAC OS 8 PROGRAM FRAMEWORK AND FONT SYSTEM         ****
REM *****                 BY ALAN YAP CHING FATT                     ****
REM *****                                                            ****
REM *********************************************************************
REM *********************************************************************

DECLARE SUB ShowHcmdButtons (x1, y1, cbrangex, cbsx2, cblist$(), CBMAX, bcol, fcol)
DECLARE SUB ShowVcmdButtons (x1, y1, cbrangey, cbsx2, cblist$(), CBMAX, bcol, fcol)
DECLARE SUB Cmdbutton (cbx, cby, cbsx, ltext$, bcol, fcol)
DECLARE SUB ShowScroll (stype$, x1, y1, slen, col)
DECLARE SUB ShowTextBox (tbx, tby, tbsx, textlen, bcol)
DECLARE SUB Hscroll (x1, y1, slen, barlen, col, min, max, value)
DECLARE SUB Vscroll (x1, y1, slen, barlen, col, min, max, value)
DECLARE SUB Loadpic (flname$, sx, sy, mx)
DECLARE SUB Box3d (x1, y1, x2, Y2, col)
DECLARE SUB Dbox (title$, x1, y1, x2, Y2, Boxcol, barcol, titlecol)
DECLARE SUB LoadMenu (x1, y1, menufile$, menucol, barcol, pastextcol, acttextcol)
DECLARE FUNCTION SelectColor (dbx, dby)
DECLARE FUNCTION DisplayMenu$ (menuno)
DECLARE FUNCTION ListBox (lbx, lby, lblen, lbrow, ldata$(), lmin, lmax, lbcol, lbarcol, ptextcol, ATEXTCOL)
DECLARE FUNCTION ActHcmdButtons (x1, y1, cbrangex, cbsx2, cblist$(), CBMAX)
DECLARE FUNCTION ActVcmdButtons (x1, y1, cbrangey, cbsx2, cblist$(), CBMAX)
DECLARE FUNCTION ActTextBox$ (tbx, tby, tbsx, textlen, fcol)
DECLARE FUNCTION Inputg$ (x5, y5, textlen, fcol, bcol)

REM **** SUPPORTING FONT SYSTEM ****
DECLARE SUB cLOCATE (tempx, tempy)
DECLARE SUB textcolor (tempcol)
DECLARE SUB loadfont (fontname$)
DECLARE SUB cprint (ltext$)
DECLARE SUB centerprint (ctx, cty, ltext$, ctsx)
DECLARE FUNCTION tlen (ltext$)
DECLARE FUNCTION clen (char$)

COMMON SHARED maxclen, charhigh, bold, textcol, currentx, currenty, vspace
COMMON SHARED menutotal, menuypos, MENUHOTKEY$, menucol$
COMMON SHARED keytrap$, pointer1, pointer2, textbuffer$

REM *** GLOBAL FONT-ATTRIBUTES ***
DIM SHARED fontdata$(95), starty(95), CHARLEN(95)

REM *** MENU SYSTEM ***
DIM SHARED menuitem$(10, 10)
DIM SHARED maxmi(10), menucsize(10), menuxpos(10)

FUNCTION ActHcmdButtons (x1, y1, cbrangex, cbsx2, cblist$(), CBMAX)
REM ********************************************************
REM *** ACTIVATE COMMAND BUTTONS - LEFT TO RIGHT        ****
REM ********************************************************
DIM cbsel, cbbar(700), cbpx(10), CBHOTKEY$

REM *** SCAN HOTKEY OF COMMAND BUTTONS ***
FOR g1 = 1 TO CBMAX
   G2 = INSTR(cblist$(g1), "&")
   IF G2 = 0 THEN F$ = CHR$(255) ELSE F$ = UCASE$(MID$(cblist$(g1), G2 + 1, 1))
   CBHOTKEY$ = CBHOTKEY$ + F$
NEXT
keytrap$ = UCASE$(keytrap$)

REM *** AUTO-SET BUTTON SIZE ***
IF cbsx2 = -1 THEN
    FOR g1 = 1 TO CBMAX
        IF tlen(cblist$(g1)) > cbsx2 THEN cbsx2 = tlen(cblist$(g1)) + 20
    NEXT
END IF

REM *** DRAW THE COMMAND BUTTONS FIRST - SIDE BY SIDE ***
IF CBMAX > 1 THEN
    REM *** DISPLAY MORE THAN ONE BUTTONS ***
    FOR gx33 = 0 TO CBMAX - 1
        cbpx(gx33 + 1) = CINT(x1 + (gx33 * ((cbrangex - cbsx2) / (CBMAX - 1))))
    NEXT
END IF


gx$ = STR$(cbsx2 - 14)
gy$ = STR$(charhigh + 1)
cbsel = pointer1

REM *** ACTIVATES THE COMMAND BUTTON ***
GET (cbpx(cbsel) - 2, y1 - 2)-STEP(1, 1), cbbar
gx2 = cbpx(cbsel) - 2

tempx$ = STR$(cbsx2 - 6)
tempy$ = STR$(charhigh)

31300

PUT (gx2, y1 - 2), cbbar, PSET
IF cbsel < 1 THEN cbsel = CBMAX
IF cbsel > CBMAX THEN cbsel = 1

gx2 = cbpx(cbsel) - 2
GET (cbpx(cbsel) - 2, y1 - 2)-STEP(cbsx2 + 4, charhigh + 12), cbbar

PSET (cbpx(cbsel) - 2, y1 + 1)
DRAW "c15 e3 r" + tempx$ + "r4 f3 d6 d" + tempy$
DRAW "c8 g3 l" + tempx$ + "l4 h3 u6 u" + tempy$

31310
F$ = UCASE$(INKEY$)
IF F$ = "" THEN F$ = CHR$(254)

IF MID$(F$, 2, 1) = "K" THEN cbsel = cbsel - 1: GOTO 31300
IF MID$(F$, 2, 1) = "M" THEN cbsel = cbsel + 1: GOTO 31300
IF F$ = CHR$(27) THEN g11 = 0: GOTO 31319
IF F$ = CHR$(13) THEN g11 = cbsel: GOTO 31319

g11 = INSTR(CBHOTKEY$, F$)
IF g11 > 0 THEN GOTO 31319

REM **** TRAP USER KEY PRESS ****
IF INSTR(1, keytrap$, "^") AND MID$(F$, 2, 1) = "H" THEN g11 = -ASC("^"): GOTO 31319
IF INSTR(1, keytrap$, "&") AND MID$(F$, 2, 1) = "P" THEN g11 = -ASC("&"): GOTO 31319
IF INSTR(1, keytrap$, F$) THEN g11 = -ASC(F$): GOTO 31319

GOTO 31310

31319
REM **** DONE WITH SELECTION ****
pointer1 = cbsel
ActHcmdButtons = g11
PUT (gx2, y1 - 2), cbbar, PSET


END FUNCTION

FUNCTION ActTextBox$ (tbx, tby, tbsx, textlen, fcol)
REM ************************************************
REM **** ACTIVATE THE TEXT-BOX                 *****
REM ************************************************
IF textlen = -1 THEN textlen = CINT((tbsx - 9) / (1 + maxclen + bold))
IF tbsx = -1 THEN tbsx = textlen * (maxclen + bold + 1) + 9
bcol = POINT(tbx + 2, tby + 2)
LINE (tbx + 1, tby + 1)-STEP(tbsx - 3, charhigh + 2), bcol, BF
temp$ = Inputg(tbx + 2, tby + 2, textlen, fcol, bcol)
ActTextBox$ = temp$

END FUNCTION

FUNCTION ActVcmdButtons (x1, y1, cbrangey, cbsx2, cblist$(), CBMAX)
REM ********************************************************
REM *** DISPLAY LIST OF COMMAND BUTTONS - TOP - DOWN    ****
REM ********************************************************
DIM cbsel, cbbar(700), cbpy(10), CBHOTKEY$, temptext$

REM *** AUTO-SET BUTTON SIZE ***
IF cbsx2 = -1 THEN
    FOR g1 = 1 TO CBMAX
        IF tlen(cblist$(g1)) > cbsx2 THEN cbsx2 = tlen(cblist$(g1)) + 20
    NEXT
END IF
keytrap$ = UCASE$(keytrap$)

REM *** SCAN HOTKEY OF COMMAND BUTTONS ***
FOR g1 = 1 TO CBMAX
   G2 = INSTR(cblist$(g1), "&")
   IF G2 = 0 THEN F$ = CHR$(255) ELSE F$ = UCASE$(MID$(cblist$(g1), G2 + 1, 1))
   CBHOTKEY$ = CBHOTKEY$ + F$
NEXT

REM *** CALCULATE POSITION OF EACH BUTTON ***
IF CBMAX > 1 THEN
    REM *** DISPLAY MORE THAN ONE BUTTONS ***
    FOR gY33 = 0 TO CBMAX - 1
        cbpy(gY33 + 1) = CINT(y1 + (gY33 * ((cbrangey - (charhigh + 8)) / (CBMAX - 1))))
    NEXT
END IF

cbsel = pointer1
REM *** ACTIVATES THE COMMAND BUTTON ***
GET (x1 - 2, cbpy(cbsel) - 2)-STEP(1, 1), cbbar
gy2 = cbpy(cbsel) - 2

tempx$ = STR$(cbsx2 - 6)
tempy$ = STR$(charhigh)

31400
PUT (x1 - 2, gy2), cbbar, PSET
IF cbsel < 1 THEN cbsel = CBMAX
IF cbsel > CBMAX THEN cbsel = 1

gy2 = cbpy(cbsel) - 2
GET (x1 - 2, cbpy(cbsel) - 2)-STEP(cbsx2 + 4, charhigh + 12), cbbar
PSET (x1 - 2, cbpy(cbsel) + 1)
DRAW "c15 e3 r" + tempx$ + "r4 f3 d6 d" + tempy$
DRAW "c8 g3 l" + tempx$ + "l4 h3 u6 u" + tempy$

31410
F$ = UCASE$(INKEY$)
IF F$ = "" THEN F$ = CHR$(254)
IF MID$(F$, 2, 1) = "H" THEN cbsel = cbsel - 1: GOTO 31400
IF MID$(F$, 2, 1) = "P" THEN cbsel = cbsel + 1: GOTO 31400
IF F$ = CHR$(27) THEN g11 = 0: GOTO 31419
IF F$ = CHR$(13) THEN g11 = cbsel: GOTO 31419

g11 = INSTR(CBHOTKEY$, F$)
IF g11 > 0 THEN GOTO 31419

REM **** TRAP USER KEY PRESS ****
IF INSTR(1, keytrap$, "<") AND MID$(F$, 2, 1) = "K" THEN g11 = -ASC("<"): GOTO 31419
IF INSTR(1, keytrap$, ">") AND MID$(F$, 2, 1) = "M" THEN g11 = -ASC(">"): GOTO 31419
IF INSTR(1, keytrap$, F$) THEN g11 = -ASC(F$): GOTO 31419

GOTO 31410

31419
REM **** DONE WITH SELECTION ****
pointer1 = cbsel
ActVcmdButtons = g11
PUT (x1 - 2, gy2), cbbar, PSET

END FUNCTION

SUB Box3d (x1, y1, x2, Y2, col)



LINE (x1 + 2, y1 + 2)-STEP(x2 - 4, Y2 - 4), col, BF
LINE (x1, y1)-STEP(x2, Y2), 8, B
LINE (x1 + 1, y1 + 1)-STEP(x2 - 2, Y2 - 2), 8, B


LINE (x1, y1)-STEP(x2, 0), 15
LINE -STEP(0, Y2), 15
LINE (x1 + 1, y1 + 1)-STEP(x2 - 2, 0), 15
LINE -STEP(0, Y2 - 2), 15



END SUB

SUB centerprint (ctx, cty, ltext$, ctsx)
REM *****************************************
REM **** Centers and print the font      ****
REM *****************************************
DIM tempx

tempx = CINT((ctsx - tlen(ltext$)) / 2)
currentx = ctx + tempx
currenty = cty
cprint ltext$

END SUB

FUNCTION clen (char$)
REM ****** RETURN THE LENGTH OF A CHARACTER ******
clen = CHARLEN(ASC(char$) - 32)

END FUNCTION

SUB cLOCATE (tempx, tempy)
currentx = tempx
currenty = tempy
END SUB

SUB Cmdbutton (cbx, cby, cbsx, ltext$, bcol, fcol)
REM ****************************************
REM *** DISPLAY A COMMAND BUTTON         ***
REM ****************************************
DIM cbsy, tempx$, tempy$

cbsy = charhigh + 8
REM *** AUTO ADJUST BUTTON ***
IF cbsx = -1 THEN cbsx = tlen(ltext$) + 20


REM *** DRAW OUTLINES OF COMMAND BUTTON ****
tempx$ = STR$(cbsx - 4)
tempy$ = STR$(cbsy - 4)
LINE (cbx + 1, cby + 1)-STEP(cbsx - 2, cbsy - 2), bcol, BF
PSET (cbx, cby + 2), 0
DRAW "e2 r" + tempx$ + " f2 d" + tempy$
DRAW " g2 l" + tempx$ + " h2 u" + tempy$
PSET (cbx + 1, cby + 2), 0
DRAW "c15 ru r" + tempx$ + " dr d" + tempy$
DRAW "c8 ld l" + tempx$ + " ul u" + tempy$


textcol = fcol
centerprint cbx + 1, cby + 5, ltext$, cbsx


END SUB

SUB cprint (ltext$)

REM **************************************************
REM **** DISPLAY OUT THE TEXT USING LOADED FONTS  ****
REM **************************************************
gx = 0

FOR g1 = 1 TO LEN(ltext$)
    c$ = MID$(ltext$, g1, 1)
    G2 = ASC(c$) - 32
    IF c$ = "&" THEN
             c$ = MID$(ltext$, g1 + 1, 1)
             LINE (currentx + gx, currenty - 1 + charhigh)-STEP(CHARLEN(ASC(c$) - 32) - 1 + bold, 0), textcol
             g3 = -1
        ELSEIF c$ <> " " THEN
            g3 = CHARLEN(G2) + bold
            PSET (currentx + gx, currenty - 1 + starty(G2)), textcol: DRAW fontdata$(G2)
            IF bold > 0 THEN PSET (currentx + gx + 1, currenty - 1 + starty(G2)), textcol: DRAW fontdata$(G2)
          ELSE
            g3 = CHARLEN(0) + bold
    END IF
    gx = CINT(gx + g3 + 1)
NEXT

currenty = currenty + charhigh + vspace

END SUB

SUB Dbox (title$, x1, y1, x2, Y2, Boxcol, barcol, titlecol)
REM ********************************************************
REM *** DRAWS A MAC-OS DIALOG BOX                        ***
REM ********************************************************
DIM barsy, x3

x2 = x2 - 2
Y2 = Y2 - 2

barsy = charhigh + 5
x3 = x1 + x2

REM *** OUTLINE ****
LINE (x1, y1)-STEP(x2, Y2), 0, B
LINE (x1 + 1, y1 + Y2 + 1)-STEP(x2, 0), 8
LINE -STEP(0, -Y2), 8
LINE (x1 + 2, y1 + Y2 + 2)-STEP(x2, 0), 8
LINE -STEP(0, -Y2), 8

REM *** UPPER BAR ***
LINE (x1 + 1, y1 + 1)-STEP(x2 - 2, 17), barcol, BF
LINE (x1 + 1, y1 + 1)-STEP(x2 - 2, 17), 8, B
LINE (x1 + 1, y1 + 1)-STEP(x2 - 2, 0), 15
LINE -STEP(0, 16), 15

REM *** LOWER BOX ***
LINE (x1 + 1, y1 + 19)-STEP(x2 - 2, Y2 - 20), Boxcol, BF
LINE (x1 + 1, y1 + 19)-STEP(x2 - 2, Y2 - 20), 8, B
LINE (x1 + 1, y1 + 19)-STEP(x2 - 2, 0), 15
LINE -STEP(0, Y2 - 20), 15

REM **** FRILLS INSIDE THE BAR ****
gx1 = CINT(((x2 - 53) - tlen(title$)) / 2)
FOR gy = 1 TO 12 STEP 2
    LINE (x1 + 19, y1 + 3 + gy)-STEP(x2 - 54, 0), 15
    LINE (x1 + 20, y1 + 4 + gy)-STEP(x2 - 54, 0), 8
    LINE (x1 + 16 + gx1, y1 + 3 + gy)-STEP(tlen(title$) + 5, 0), barcol
    LINE (x1 + 17 + gx1, y1 + 4 + gy)-STEP(tlen(title$) + 5, 0), barcol
NEXT
textcol = titlecol
centerprint x1 + 20, y1 + 5, title$, x2 - 53

REM **** ICONS ****
temptext$ = "c8 r10 d10 g c15 l10 u10 r c0 r9d9l9u9 f c15 r7d7 c8l7u7 "
PSET (x1 + 5, y1 + 4): DRAW temptext$
PSET (x1 + x2 - 29, y1 + 4): DRAW temptext$
PSET (x1 + x2 - 14, y1 + 4): DRAW temptext$

PSET (x1 + x2 - 27, y1 + 10): DRAW "c8 r3u4"
PSET (x1 + x2 - 13, y1 + 8): DRAW "c8 r6 bd2 l6"



END SUB

FUNCTION DisplayMenu$ (menuno)
REM ************************************************
REM **** DISPLAY AND ACTIVATE MAC-MENUBOX      *****
REM ************************************************
DIM menux, menuy, menusx, menusY, menuttx, menutty
DIM menusel, menuitembar(400), mirhigh, MIHOTKEY$(15)
DIM menucol, menubarcol, acttext, pasttext
DIM im1(6000)

31100
IF menuno < 1 THEN menuno = menutotal
IF menuno > menutotal THEN menuno = 1
G2 = 0
menusel = 1
mirhigh = charhigh + 4
menux = menuxpos(menuno)
menuy = menuypos - 1
menuttx = menux
menutty = menuy - (charhigh + 5)


menucol = ASC(LEFT$(menucol$, 1))
menubarcol = ASC(MID$(menucol$, 2, 1))
pastextcol = ASC(MID$(menucol$, 3, 1))
acttextcol = ASC(RIGHT$(menucol$, 1))


REM *** HIGHLIGHT ACTIVE MENUTITLE ****
F$ = STR$(tlen(menuitem$(menuno, 0)) + 6)
gy = charhigh + 4
GET (menuttx, menutty)-STEP(VAL(F$), gy), menuitembar

LINE (menuttx, menutty)-STEP(tlen(menuitem$(menuno, 0)) + 6, gy), menubarcol, BF
textcol = acttextcol
cLOCATE menuttx + 4, menutty + 3: cprint menuitem$(menuno, 0)


REM *** SETUP VARIABLES AND CAPTURE BACKGROUND IMAGE ***
menusx = menucsize(menuno) + 25 + (4 * CHARLEN(0))
menusY = (maxmi(menuno) * (mirhigh)) + 4
IF menux + menusx > 639 THEN menux = menuttx - (menusx - VAL(F$))
IF menuy + menusY > 479 THEN menuy = menutty - menusY
GET (menux, menuy)-STEP(menusx + 1, menusY + 1), im1

REM *** DRAW THE MENUBOX ****
LINE (menux, menuy)-STEP(menusx, menusY), 0, B
LINE (menux + 1, menuy + menusY + 1)-STEP(menusx, 0), 0
LINE -STEP(0, -menusY), 0

LINE (menux + 1, menuy + 1)-STEP(menusx - 2, menusY - 2), menucol, BF
LINE (menux + 1, menuy + 1)-STEP(menusx - 2, menusY - 2), 8, B
LINE (menux + 1, menuy + 1)-STEP(menusx - 2, 0), 15
LINE -STEP(0, menusY - 2), 15

REM *** SCAN HOTKEY OF COMMAND BUTTONS ***
MIHOTKEY$ = ""
FOR g1 = 1 TO maxmi(menuno)
   G2 = INSTR(menuitem$(menuno, g1), "&")
   IF G2 = 0 THEN F$ = CHR$(255) ELSE F$ = UCASE$(MID$(menuitem$(menuno, g1), G2 + 1, 1))
   MIHOTKEY$ = MIHOTKEY$ + F$
NEXT

REM *** PUT IN MENUITEMS ***
textcol = pastextcol
FOR gy = 1 TO maxmi(menuno)
    cLOCATE menux + 12 + (CHARLEN(0) * 2), menuy + 5 + ((gy - 1) * mirhigh)
    cprint menuitem$(menuno, gy)
NEXT

GOSUB 31150


REM ***** ACTIVATE THE MENU CONTROL SYSTEM ****
31110
F$ = UCASE$(INKEY$)
IF F$ = "" THEN F$ = CHR$(254)
IF MID$(F$, 2, 1) = "H" THEN GOSUB 31140: menusel = menusel - 1: GOSUB 31150
IF MID$(F$, 2, 1) = "P" THEN GOSUB 31140: menusel = menusel + 1: GOSUB 31150
IF MID$(F$, 2, 1) = "K" THEN GOSUB 31160: menuno = menuno - 1: GOTO 31100
IF MID$(F$, 2, 1) = "M" THEN GOSUB 31160: menuno = menuno + 1: GOTO 31100
IF F$ = CHR$(27) OR F$ = CHR$(13) THEN GOTO 31190
G2 = INSTR(MIHOTKEY$, F$)
IF G2 > 0 THEN menusel = G2: GOTO 31190

GOTO 31110

REM *** REMOVE MENUBAR ***
31140
gy = (menusel - 1) * mirhigh
LINE (menux + 2, menuy + gy + 2)-STEP(menusx - 4, mirhigh), menucol, BF
textcol = pastextcol
cLOCATE menux + 12 + (CHARLEN(0) * 2), menuy + gy + 5: cprint menuitem$(menuno, menusel)
RETURN

REM *** REDRAW MENUBAR ***
31150
IF menusel < 1 THEN menusel = maxmi(menuno)
IF menusel > maxmi(menuno) THEN menusel = 1
gy = (menusel - 1) * mirhigh
LINE (menux + 2, menuy + gy + 2)-STEP(menusx - 4, mirhigh), menubarcol, BF
textcol = acttextcol
cLOCATE menux + 12 + (CHARLEN(0) * 2), menuy + gy + 5: cprint menuitem$(menuno, menusel)
RETURN

REM *** CLEAR MENUBOX ***
31160
PUT (menux, menuy), im1, PSET
PUT (menuttx, menutty), menuitembar, PSET
RETURN

REM *** EXIT THIS SUBROUTINES ****
31190
GOSUB 31160
IF F$ = CHR$(27) THEN
        DisplayMenu$ = CHR$(27)
    ELSE
        DisplayMenu$ = LTRIM$(RTRIM$(STR$(menuno))) + "." + LTRIM$(RTRIM$(STR$(menusel)))
END IF

END FUNCTION

SUB Hscroll (x1, y1, slen, barlen, col, min, max, value)
REM ***********************************
REM ** UPDATES HORIZONTAL SCROLL    ***
REM ***********************************

REM ** UPDATE BAR SKELETON ***
tempcol = POINT(x1 + 3, y1 + 3)
LINE (x1 + 17, y1)-STEP(slen - 35, 16), tempcol, BF
LINE (x1 + 16, y1)-STEP(slen - 34, 16), 0, B
LINE (x1 + 17, y1 + 1)-STEP(slen - 35, 14), 15, B
LINE (x1 + 17, y1 + 1)-STEP(slen - 35, 0), 8
LINE -STEP(0, 13), 8

REM ** PUT FRILLS INSIDE IT ***
FOR gy1 = 3 TO 13 STEP 2
    LINE (x1 + 18, y1 + gy1)-STEP(slen - 37, 0), 8
NEXT

REM *** DRAW THE BAR POINTER ***
blen$ = STR$(barlen - 3)
aval = CINT((value - min) / (max - min) * (slen - 32 - barlen))
LINE (x1 + 18 + aval, y1 + 2)-STEP(barlen - 3, 12), col, BF
LINE (x1 + 16 + aval, y1 + 1)-STEP(barlen - 1, 14), 0, B
PSET (x1 + 17 + aval, y1 + 1):   DRAW "c15 R" + blen$ + "D14 c8 L" + blen$ + "U14"

REM ** PUT FRILLS INSIDE IT ***
FOR gx1 = 1 TO barlen - 8 STEP 2
    PSET (x1 + 19 + aval + gx1, y1 + 4): DRAW "c15 D7 f c8 U7"
NEXT

END SUB

FUNCTION Inputg$ (x5, y5, textlen, fcol, bcol)
REM *****************************************************
REM *** KINDA LIKE INPUT STATEMENT...JUST MORE FLEXIBLE!
REM *****************************************************
DIM text$, cpos, X6

text$ = textbuffer$: cpos = 1: X6 = 0
LINE (x5, y5)-STEP(textlen * (maxclen + bold + 1) + 5, charhigh), bcol, BF
REM **** APPEND TO PREVIOUS INPUT ****
IF text$ <> "" THEN
    X6 = tlen(textbuffer$) + 1
    cpos = LEN(text$) + 1
    textcol = fcol
    cLOCATE x5 + 1, y5 + 1: cprint text$
END IF

LINE (x5 + X6 + 1, y5)-STEP(0, charhigh - 1), fcol, B


textcol = fcol
DO UNTIL F$ = CHR$(27) OR F$ = CHR$(13)
    textbuffer$ = text$
    F$ = INPUT$(1)
    IF F$ = "" THEN F$ = CHR$(255)

    ' Enter the font
    IF ASC(F$) >= 32 AND ASC(F$) <= 127 AND cpos <= textlen THEN
        LINE (x5 + X6 + 1, y5)-STEP(0, charhigh), bcol, B
        text$ = text$ + F$
        cpos = cpos + 1
        IF F$ <> " " THEN
            cLOCATE x5 + X6 + 1, y5 + 1
            cprint F$
        END IF

        X6 = X6 + CHARLEN(ASC(F$) - 32) + 1 + bold
        LINE (x5 + X6 + 1, y5)-STEP(0, charhigh), fcol, B
    END IF

    ' Backspace
    IF F$ = CHR$(8) AND cpos > 1 THEN
        LINE (x5 + X6 + 1, y5)-STEP(0, charhigh), bcol, B
        cpos = cpos - 1
        g22 = CHARLEN(ASC(RIGHT$(text$, 1)) - 32) + 1 + bold
        X6 = X6 - g22
        LINE (x5 + X6 + 1, y5)-STEP(g22 - 1, charhigh), bcol, BF
        LINE (x5 + X6 + 1, y5)-STEP(0, charhigh), fcol, B
        text$ = LEFT$(text$, LEN(text$) - 1)
    END IF

    ' Trap user preferred keys
    IF INSTR(1, keytrap$, F$) THEN text$ = "": EXIT DO
LOOP

IF F$ = CHR$(27) THEN text$ = ""
IF text$ = "" THEN Inputg$ = CHR$(27) ELSE Inputg$ = RTRIM$(text$)


END FUNCTION

FUNCTION ListBox (lbx, lby, lblen, lbrow, ldata$(), lmin, lmax, lbcol, lbarcol, ptextcol, ATEXTCOL)
REM ***********************************************
REM *** DISPLAY AND ACTIVATE LISTBOX            ***
REM ***********************************************
DIM lbsx, lbsy, lbcy2, lbcy1, listsel, totalrow

REM **** DRAW OUT THE LISTBOX FIRST ****
keytrap$ = UCASE$(keytrap$)
lbcy1 = pointer1: lbcy2 = pointer2
totalrow = lmax - lmin + 1
lbarsy = charhigh + 3
lbsy = (lbrow * lbarsy) + 2
lbsx = (lblen * (maxclen + 1 + bold))
IF totalrow <= lbrow THEN lbsx = lbsx - 16

tempx$ = STR$(lbsx + 2): tempy$ = STR$(lbsy + 2)
LINE (lbx + 1, lby + 1)-STEP(lbsx - 2, lbsy - 2), lbcol, BF
LINE (lbx, lby)-STEP(lbsx, lbsy), 8, B
PSET (lbx - 2, lby - 1)
DRAW "c15 e r" + tempx$ + "f d" + tempy$ + "c8 g l" + tempx$ + "h u" + tempy$

IF totalrow <= lbrow THEN
    lbsx = lbsx + 16
  ELSE
    CALL ShowScroll("^", lbx + lbsx - 16, lby, lbsy + 1, 7)
END IF

GOSUB 31250

REM ***********************************
REM *** ACTIVATING THE LISTBOX     ****
REM ***********************************

31200
REM *** HIGHLIGHT POINTER ****
gy2 = lby - charhigh + (lbcy2 * lbarsy)
IF lbrow > totalrow THEN lbcy1 = 1
listsel = (lmin - 1) + (lbcy1 - 1) + lbcy2
LINE (lbx + 1, gy2 - 2)-STEP(lbsx - 18, lbarsy), lbarcol, BF

textcol = ATEXTCOL
cLOCATE lbx + 4, gy2: cprint ldata$(listsel)

REM *** REFRESH SCROLLBAR (if there is any) ****
IF totalrow > lbrow THEN CALL Vscroll(lbx + lbsx - 16, lby, lbsy + 1, 20, lbarcol, lmin, lmax, listsel)

REM *** ASK USER KEYPRESS ***
31210
F$ = UCASE$(INKEY$)
IF F$ = "" THEN F$ = CHR$(255)
REM **** STANDARD KEY CONTROLS ****
IF MID$(F$, 2, 1) = "H" AND lbcy2 = 1 THEN lbcy1 = lbcy1 - 1: GOSUB 31250: GOTO 31200
IF MID$(F$, 2, 1) = "P" AND lbcy2 = lbrow THEN lbcy1 = lbcy1 + 1: GOSUB 31250: GOTO 31200
IF MID$(F$, 2, 1) = "H" AND lbcy2 > 1 THEN GOSUB 31230: lbcy2 = lbcy2 - 1: GOTO 31200
IF MID$(F$, 2, 1) = "P" AND lbcy2 < lbrow AND lbcy2 < totalrow THEN GOSUB 31230: lbcy2 = lbcy2 + 1: GOTO 31200
IF F$ = CHR$(27) THEN listsel = 0: GOTO 31290
IF F$ = CHR$(13) THEN GOTO 31290

REM **** TRAP USER KEY PRESS ****
IF INSTR(1, keytrap$, "<") AND MID$(F$, 2, 1) = "K" THEN F$ = "<": listsel = 0: GOTO 31290
IF INSTR(1, keytrap$, ">") AND MID$(F$, 2, 1) = "M" THEN F$ = ">": listsel = 0: GOTO 31290
IF INSTR(1, keytrap$, F$) THEN listsel = 0: GOTO 31290

GOTO 31210

31230
REM *** UNHIGHLIGHT POINTER ******
gy2 = lby - charhigh + (lbcy2 * lbarsy)
listsel = (lmin - 1) + (lbcy1 - 1) + lbcy2
LINE (lbx + 1, gy2 - 2)-STEP(lbsx - 18, lbarsy), lbcol, BF
textcol = ptextcol
cLOCATE lbx + 4, gy2: cprint ldata$(listsel)
RETURN

31250
REM ****** REDRAW LISTBOX CONTENTS ****
IF lbcy1 < 1 THEN lbcy1 = 1: RETURN
IF lbcy1 > totalrow - (lbrow - 1) AND lbrow <= totalrow THEN lbcy1 = totalrow - (lbrow - 1): RETURN
LINE (lbx + 1, lby + 1)-STEP(lbsx - 18, lbsy - 2), lbcol, BF

textcol = ptextcol
FOR gy = 1 TO lbrow
    IF gy > totalrow THEN EXIT FOR
    gy2 = lby - charhigh + (gy * lbarsy)
    G2 = (lmin - 1) + (lbcy1 - 1) + gy
    cLOCATE lbx + 4, gy2: cprint ldata$(G2)
NEXT

RETURN

31290
REM ****** EXIT LISTBOX ******
REM ***** SOFTEN THE CURRENT SELECTED LIST ITEM ******
pointer1 = lbcy1: pointer2 = lbcy2
LINE (lbx + 1, gy2 - 2)-STEP(lbsx - 18, lbarsy), ATEXTCOL, BF
g11 = (lmin - 1) + (lbcy1 - 1) + lbcy2
textcol = lbarcol: cLOCATE lbx + 4, gy2: cprint ldata$(g11)
IF listsel < 1 THEN ListBox = -(ASC(F$)) ELSE ListBox = listsel

END FUNCTION

SUB loadfont (fontname$)

REM **************************************
REM *** START LOADING THE FILE!       ****
REM **************************************
DIM text$

OPEN "I", #1, fontname$ + ".FNT"

' Load dummy header
LINE INPUT #1, text$
LINE INPUT #1, text$

' Load Character height
LINE INPUT #1, text$
text$ = RTRIM$(text$)
charhigh = VAL(text$)

' Load Font-data
gy = 1
maxclen = 0
vspace = 2

LINE INPUT #1, text$
text$ = RTRIM$(text$)
DO UNTIL text$ = "[END]" OR EOF(1)
    fontdata$(gy) = RIGHT$(text$, LEN(text$) - 2)
    CHARLEN(gy) = ASC(LEFT$(text$, 1)) - 64
    IF CHARLEN(gy) > maxclen THEN maxclen = CHARLEN(gy)
    starty(gy) = ASC(MID$(text$, 2, 1)) - 64
    gy = gy + 1
    LINE INPUT #1, text$
    text$ = RTRIM$(text$)
LOOP
CLOSE #1
CHARLEN(0) = 6


END SUB

SUB LoadMenu (x1, y1, menufile$, menucol, menubarcol, pastextcol, acttextcol)

REM ************************************************************
REM **** SETUP MENU STRUCTURE                               ****
REM ************************************************************
OPEN "I", #1, menufile$ + ".MNU"

REM **** LOAD MENU ITEMS FROM FILE INTO MEMORY ****
LINE INPUT #1, D$
DO UNTIL D$ = "[END]"
    menutotal = menutotal + 1
    LINE INPUT #1, D$
    D$ = LTRIM$(RTRIM$(D$))
    IF LEFT$(D$, 2) = "@ " THEN
        menuitem$(menutotal, 0) = RIGHT$(D$, LEN(D$) - 2)
        DO UNTIL D$ = "@"
            maxmi(menutotal) = maxmi(menutotal) + 1
            LINE INPUT #1, D$
            D$ = LTRIM$(RTRIM$(D$))
            IF LEFT$(D$, 2) = "- " THEN menuitem$(menutotal, maxmi(menutotal)) = RIGHT$(D$, LEN(D$) - 2)
            g1 = tlen(menuitem$(menutotal, maxmi(menutotal)))
            IF g1 > menucsize(menutotal) THEN menucsize(menutotal) = g1
        LOOP
    END IF
LOOP

CLOSE #1


D$ = ""
menuxpos(1) = x1 - 4
FOR g1 = 1 TO 10
    maxmi(g1) = maxmi(g1) - 1
     IF g1 > 1 THEN menuxpos(g1) = x1 + tlen(D$) - (g1 + 2)
    D$ = D$ + menuitem$(g1, 0) + "  "
NEXT
menutotal = menutotal - 1
D$ = RTRIM$(D$)
menuypos = y1 + charhigh + 3
MENUHOTKEY$ = ""

FOR g1 = 1 TO LEN(D$)
    IF MID$(D$, g1, 1) = "&" THEN MENUHOTKEY$ = MENUHOTKEY$ + MID$(D$, g1 + 1, 1)
NEXT

REM **** DISPLAY THE MENU BAR ****
textcol = pastextcol
cLOCATE x1, y1: cprint D$

menucol$ = ""
menucol$ = menucol$ + CHR$(menucol) + CHR$(menubarcol)
menucol$ = menucol$ + CHR$(pastextcol) + CHR$(acttextcol)

END SUB

SUB Loadpic (flname$, sx, sy, mx)
REM **** LOAD PICTURE BLOCKS ***
OPEN "I", #1, flname$
INPUT #1, a$
 
IF a$ = "<YCF>" THEN
  FOR gx21 = 1 TO 70
    INPUT #1, g1$
    FOR GY21 = 1 TO 70
        col = ASC(MID$(g1$, GY21, 1)) - 50
        PSET (sx - 1 + gx21, sy - 1 + GY21), col
    NEXT
  NEXT
ELSEIF a$ = "<TXT>" THEN
  PSET (sx, sy)
  FOR gx21 = 1 TO 70
    INPUT #1, g1$
    DRAW g1$
  NEXT
END IF




CLOSE #1

END SUB

FUNCTION SelectColor (dbx, dby)
REM *******************************************************
REM **** LET USER PICK COLOR FROM COLOR PALETTE       *****
REM *******************************************************
REM **** RETURNS THE COLOR SELECTED - (0 TO 15)        ****
REM **** IF USER PRESS ESC, RETURNS -1                 ****
REM *******************************************************

DIM lr, ud, refr
DIM background(2000)       'STORE BACKGROUND IMAGE

lr = 0
ud = 0
refr = 1


REM **** DISPLAY OUT COLOR PALETTE  *****
GET (dbx, dby)-STEP(180, 78), background
CALL Dbox("Pick Color", dbx, dby, 180, 78, 7, 1, 14)
FOR gx21 = 0 TO 7
  FOR GY21 = 0 TO 1
    gx22 = dbx + 9 + (gx21 * 21)
    gy22 = dby + 31 + (GY21 * 21)
    LINE (gx22, gy22)-STEP(15, 15), (gx21 + (GY21 * 8)), BF
    PSET (gx22, gy22): DRAW "c8 r15d15 c15 l15u15"
  NEXT
NEXT



DO UNTIL ((F$ = CHR$(13)) OR (F$ = CHR$(27)))

REM **** REFRESH POINTER AS USER MOVES ****
 IF refr = 1 THEN
    FOR gx21 = 0 TO 7
      FOR GY21 = 0 TO 1
        gx22 = dbx + 6 + (gx21 * 21)
        gy22 = dby + 28 + (GY21 * 21)
        LINE (gx22, gy22)-STEP(21, 21), 7, B
      NEXT
    NEXT
    IF ud < 0 THEN ud = 1
    IF ud > 1 THEN ud = 0
    IF lr < 0 THEN lr = 7
    IF lr > 7 THEN lr = 0
    PSET (dbx + 6 + (lr * 21), dby + 28 + (ud * 21)): DRAW "c15 r21d21 c8 l21u21"
  END IF

REM **** GET USER INPUT ****
  refr = 0
  F$ = INKEY$
  IF MID$(F$, 2, 1) = "H" THEN ud = ud - 1: refr = 1
  IF MID$(F$, 2, 1) = "P" THEN ud = ud + 1: refr = 1
  IF MID$(F$, 2, 1) = "K" THEN lr = lr - 1: refr = 1
  IF MID$(F$, 2, 1) = "M" THEN lr = lr + 1: refr = 1

LOOP


REM *** RESTORE BACKGROUND *****

IF F$ = CHR$(13) THEN SelectColor = POINT(dbx + 12 + (lr * 21), dby + 38 + (ud * 21)) ELSE SelectColor = -1
PUT (dbx, dby), background, PSET

END FUNCTION

SUB ShowHcmdButtons (x1, y1, cbrangex, cbsx2, cblist$(), CBMAX, bcol, fcol)
REM ********************************************************
REM *** DISPLAY LIST OF COMMAND BUTTONS - LEFT TO RIGHT ****
REM ********************************************************

REM *** AUTO-SET BUTTON SIZE ***
IF cbsx2 = -1 THEN
    FOR g1 = 1 TO CBMAX
        IF tlen(cblist$(g1)) > cbsx2 THEN cbsx2 = tlen(cblist$(g1)) + 20
    NEXT
END IF

REM *** DRAW THE COMMAND BUTTONS FIRST - SIDE BY SIDE ***
IF CBMAX > 1 THEN
    REM *** DISPLAY MORE THAN ONE BUTTONS ***
    FOR gx33 = 0 TO CBMAX - 1
        gy34 = CINT(x1 + (gx33 * ((cbrangex - cbsx2) / (CBMAX - 1))))
        CALL Cmdbutton(gy34, y1, cbsx2, cblist$(gx33 + 1), bcol, fcol)
    NEXT
END IF

END SUB

SUB ShowScroll (stype$, x1, y1, slen, col)
REM *********************************************
REM *** DISPLAY THE SCROLL                   ****
REM *********************************************
DIM arrow$

text$ = "c15 r14d14 c8 l14u13"

IF stype$ = "^" THEN
    REM *** DRAW TOP,BOTTOM SCROLL BUTTON ***
    arrow$ = "c0 r8g l6f r4g l2rd"
    LINE (x1, y1)-STEP(16, slen - 1), col, BF
    LINE (x1, y1 + slen - 17)-STEP(16, 16), 0, B
    LINE (x1, y1)-STEP(16, 16), 0, B
    PSET (x1 + 1, y1 + slen - 16): DRAW text$
    PSET (x1 + 1, y1 + 1): DRAW text$
    PSET (x1 + 4, y1 + slen - 11): DRAW "a0" + arrow$
    PSET (x1 + 12, y1 + 9): DRAW "a2" + arrow$
ELSE
    REM *** DRAW LEFT,RIGHT SCROLL BUTTON ***
    arrow$ = "c0 d8e u6f d4e u2Dr"
    LINE (x1, y1)-STEP(slen - 1, 16), col, BF
    LINE (x1 + slen - 17, y1)-STEP(16, 16), 0, B
    LINE (x1, y1)-STEP(16, 16), 0, B
    PSET (x1 + 1, y1 + 1): DRAW text$
    PSET (x1 + slen - 16, y1 + 1): DRAW text$
    PSET (x1 + slen - 11, y1 + 4): DRAW "a0" + arrow$
    PSET (x1 + 9, y1 + 12): DRAW "a2" + arrow$
END IF

DRAW "a0"



END SUB

SUB ShowTextBox (tbx, tby, tbsx, textlen, bcol)
REM ************************************************
REM **** SHOW THE TEXT-BOX                     *****
REM ************************************************
IF textlen = -1 THEN textlen = CINT((tbsx - 9) / (1 + maxclen + bold))
IF tbsx = -1 THEN tbsx = textlen * (maxclen + bold + 1) + 9
LINE (tbx, tby)-STEP(tbsx - 1, charhigh + 4), 0, B
LINE (tbx + 1, tby + 1)-STEP(tbsx - 3, charhigh + 2), bcol, BF
LINE (tbx + 1, tby + charhigh + 5)-STEP(tbsx - 1, 0), 8
LINE -STEP(0, -charhigh - 4), 8

END SUB

SUB ShowVcmdButtons (x1, y1, cbrangey, cbsx2, cblist$(), CBMAX, bcol, fcol)

REM *** AUTO-SET BUTTON SIZE ***
IF cbsx2 = -1 THEN
    FOR g1 = 1 TO CBMAX
        IF tlen(cblist$(g1)) > cbsx2 THEN cbsx2 = tlen(cblist$(g1)) + 20
    NEXT
END IF

REM *** DRAW THE COMMAND BUTTONS FIRST - SIDE BY SIDE ***
IF CBMAX > 1 THEN
    REM *** DISPLAY MORE THAN ONE BUTTONS ***
    FOR gY33 = 0 TO CBMAX - 1
        gy34 = CINT(y1 + (gY33 * ((cbrangey - (charhigh + 8)) / (CBMAX - 1))))
        CALL Cmdbutton(x1, gy34, cbsx2, cblist$(gY33 + 1), bcol, fcol)
    NEXT
END IF

END SUB

SUB textcolor (tempcol)
textcol = tempcol

END SUB

FUNCTION tlen (ltext$)
REM *********************************************
REM *** CALCULATE LENGTH OF TEXT IN PIXELS   ****
REM *********************************************
g23 = LEN(ltext$) - 1

FOR g22 = 1 TO LEN(ltext$)
    c$ = MID$(ltext$, g22, 1)
    IF c$ = "&" THEN g23 = g23 - (CHARLEN(ASC(c$) - 32) + bold)
    g23 = g23 + CHARLEN(ASC(c$) - 32) + bold
NEXT
tlen = g23

END FUNCTION

SUB Vscroll (x1, y1, slen, barlen, col, min, max, value)
REM ***********************************
REM ** UPDATES VERTICAL SCROLL      ***
REM ***********************************
DIM tempcol

REM ** UPDATE BAR SKELETON ***
tempcol = POINT(x1 + 3, y1 + 3)
LINE (x1, y1 + 17)-STEP(16, slen - 35), tempcol, BF
LINE (x1, y1 + 15)-STEP(15, slen - 32), 0, B
LINE (x1 + 1, y1 + 17)-STEP(15, slen - 35), 8, B
LINE (x1 + 1, y1 + 17)-STEP(0, slen - 35), 15
LINE -STEP(13, 0), 15

REM ** PUT FRILLS INSIDE IT ***
FOR gx1 = 3 TO 13 STEP 2
    LINE (x1 + gx1, y1 + 18)-STEP(0, slen - 37), 8
NEXT

REM *** DRAW THE BAR POINTER ***
blen$ = STR$(barlen - 3)
aval = CINT((value - min) / (max - min) * (slen - 32 - barlen))
LINE (x1 + 2, y1 + 18 + aval)-STEP(12, barlen - 3), col, BF
LINE (x1 + 1, y1 + 16 + aval)-STEP(14, barlen - 1), 0, B
PSET (x1 + 1, y1 + 17 + aval): DRAW "c15 r14 d" + blen$ + " c8 l14 u" + blen$

REM ** PUT FRILLS INSIDE IT ***
FOR gy1 = 1 TO barlen - 8 STEP 2
    PSET (x1 + 4, y1 + 19 + aval + gy1): DRAW "c15 r7 f c8 l7"
NEXT

END SUB

